require("factsheet")

apply_sulfur_fuel_stats(data.raw.item.sulfur)

if appmod and type(appmod) == "table" then
	appmod.blacklist["assembling-machine-3"] = true
end

if appmod and type(appmod) == "table" then
	appmod.blacklist["centrifuge"] = true
end

local still_name    = settings.startup["adamo-chemical-still"].value
local reactor_name  = settings.startup["adamo-chemical-reactor"].value
local mixer_name    = settings.startup["adamo-chemical-mixer"].value
local kiln_name     = settings.startup["adamo-chemical-kiln"].value
local screener_name = settings.startup["adamo-chemical-screener"].value

add_string_to_table(
	data.raw["assembling-machine"]["oil-refinery"]
	.crafting_categories,
	"adamo-chemical-vaporworks"
)

data.raw["assembling-machine"]["assembling-machine-3"]
.fluid_boxes = chem_assembling_machine_fluid_boxes()
table.insert(
	data.raw["assembling-machine"]["assembling-machine-3"].crafting_categories,
	"adamo-chemical-manufacturing"
)
table.insert(
	data.raw["assembling-machine"]["assembling-machine-2"].crafting_categories,
	"adamo-chemical-manufacturing"
)

adamo.apply.centrifuge()
add_string_to_table(
	data.raw["assembling-machine"].centrifuge.crafting_categories,
	"adamo-chemical-separation"
)

if data.raw["assembling-machine"][still_name] then
	add_string_to_table(
		data.raw["assembling-machine"][still_name].crafting_categories,
		"adamo-chemical-vaporworks"
	)
end

if data.raw["assembling-machine"][reactor_name] then
	add_strings_to_table(
		data.raw["assembling-machine"][reactor_name]
		.crafting_categories,
		{
			"adamo-chemical-disassociation",
			"adamo-chemical-recovery",
			"adamo-chemical-displacement",
			"adamo-chemical-activation",
			"adamo-chemical-deposition"
		}
	)
end

if data.raw["assembling-machine"][mixer_name] then
	add_strings_to_table(
		data.raw["assembling-machine"][mixer_name]
		.crafting_categories,
		{
			"adamo-chemical-binding",
			"adamo-chemical-disassociation",
			"adamo-chemical-recovery",
			"adamo-chemical-displacement",
			"adamo-chemical-activation"
		}
	)
	adamochemical.mixer = true
else
	for _,name in pairs({
			"assembling-machine-1",
			"assembling-machine-2",
			"assembling-machine-3"
	}) do
		add_string_to_table(
			data.raw["assembling-machine"][name]
			.crafting_categories,
			"adamo-chemical-binding"
		)
	end
end

if data.raw["assembling-machine"][kiln_name] then
	add_string_to_table(
		data.raw["assembling-machine"][kiln_name]
		.crafting_categories,
		"adamo-chemical-firing"
	)
end

adamo.tech.add.recipe("advanced-material-processing-2","centrifuge")
adamo.tech.add.prereq("uranium-processing","advanced-material-processing-2")
